

# Demo

### [https://codecrib.gitlab.io/react/cats/](https://codecrib.gitlab.io/react/cats/)

## Tech Stack
- state management : redux, react-redux, redux-thunk
- ui : ant design and styled-components for some minor tweaks
- husky pre-commit hook to keep the repo clean
- ci/cd : gitlab-ci used to deploy on gitlab pages

## Further Improvements

- integration tests with msw mocked api calls
- refactor component composition to improve reusability and testing
- cypress e2e tests
- cleaning magic strings
- seperate api calls in its folder for better structure and improved testing
- improvement of models
    - auto generation of models  from swagger.json
    - mapping api responses to defined types
    - getting rid of any types
- scoring fetches all pages of votes then calculates scores



## Available Scripts

In the project directory, you can run:

### `yarn start`

Runs the app in the development mode.\  
Open [http://localhost:3000](http://localhost:3000) to view it in the browser.

The page will reload if you make edits.\  
You will also see any lint errors in the console.

### `yarn test`

Launches the test runner in the interactive watch mode.\  
See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.

### `yarn lint`
Launches the eslint

### `yarn build`

Builds the app for production to the `build` folder.\  
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.\  
Your app is ready to be deployed!

See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.

### `yarn eject`

**Note: this is a one-way operation. Once you `eject`, you can’t go back!**

If you aren’t satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.

Instead, it will copy all the configuration files and the transitive dependencies (webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you’re on your own.

You don’t have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn’t feel obligated to use this feature. However we understand that this tool wouldn’t be useful if you couldn’t customize it when you are ready for it.  
  
